//
// $Id: hparser.cls,v 1.1 1999/11/09 01:37:24 vszel Exp $
//

//*******************************************************************
// hparser.cls: Hessmark parser: a '#'-al kezdd sorok elemzse.
// 1999, Csiszr Levente

// A PARSER-tl rkl.
// Ez az elemz vgzi el a '#'-al kezdd sorok elemzst.
// A nv s a sor (lparser) elemz ltal ksztett tokeneket vr az 
// inputrl.

// A #-os sorokat feldolgozza, a tbbit tengedi.

class HPARSER PARSER
   
   attrib soreleje
   attrib defdict
   attrib xtrdict
   attrib ifStack
   attrib branch   // .t., ha egy #if igaz gn vagyunk, vagy nem
                   // vagyunk if-ben, .f., ha egy #if hamis gn 
                   // vagyunk, nil, ha egy if hamis gn belli 
                   // if-en vagyunk.
                   
   attrib inclObj  // Egy objektum, amiben vezetjk az include 
                   // filket.
      
   attrib lastEos  // Az utols eos token.
   
   rmethod readItem()
   // Olvas egy elemet. 
   // Ret: Az elem, ha OK, nil, ha vge van a streamnek, vagy ha
   //      hiba volt.

   // nmethod addBuf(anItem)
   // Hozzad egy elemet a pufferhez. Az elem lehet specilis is.

   // nmethod getStr()
   // Megadja a buf tartalmt stringknt.
   // A nem stringeket eldobja.
   
   // nmethod rds()
   // Olvas egy karatert a readInput()-al a buf-ba.
   // Az olvasott rtket a buf-ba is beleteszi, ha az nem az eof.
   
   // nmethod unrds(n)
   // A buf utols n elemt visszateszi az inputra. Az item-et trli.
   // Azt adja vissza, hogy hny elemet sikerlt visszatenni.
   // Ha az n nil, akkor egyet tesz vissza.
      
   nmethod parseLine()
   // Ez vgzi a tnyleges elemzst, rekurzvan is lehet hvni.
   // A this:item-t elemzi, szksg esetn mg olvashat.
   
   nmethod parseFalseLine()
   // Egy #if hamis gn vgzi az elemzst.
   // A this:item-t elemzi, szksg esetn mg olvashat.
   
   nmethod parseDefine{hpr_prsDefine}(mnameToken)
   // # define elemz.
   
   nmethod parseUndef{hpr_prsUndef}(mnameToken)
   // # undef elemz.
   
   nmethod parseTranslate(mNameToken)
   // # xtranslate, etc elemz.
   
   nmethod parseIfdef{hpr_prsIfdef}(mnameToken,ifdefType)
   
   nmethod parseElse{hpr_prsElse}(mnameToken)

   nmethod parseEndif{hpr_prsEndif}(mnameToken)

   nmethod parseInclude(mnameToken)
   
   nmethod parseLTranslate(mnameToken)
   // A # xtranslate bal oldalnak az elemzje.
   
   nmethod parseRTranslate(mnameToken)
   // A # xtranslate jobb oldalnak az elemzje.
   
   nmethod addDefine{hpr_addDefine}(mnameToken,name,params)
   // Felvesz a #define sztrba egy elemet name nven.
   // A definci trzse a parserBuffer-ben van.
   // Az mnameToken jelzi, hogy hol volt a definci.
   // Ha a nv mr ltezik, akkor az errorGen-el legyrt egy
   // hiba tokent a az mnameToken-bl.
   
   nmethod addXTranslate(mnameToken,leftSide,rightSide)
   // nmethod addXTranslate{hpr_addXTranslate}(mnameToken,leftSide,rightSide)
   // Felvesz a #xtranslate sztrba egy elemet.
   // Az mnameToken jelzi, hogy hol volt a definci.
   
   nmethod sorNyel(kiirBlock)
   // Trli a parserBuffer-t, majd a sor vgig lenyeli az item-eket.
   // A sorvgjelet a parserpuffer-ben hagyja.
   // Ha a kiirBlock egy block, akkor a token stringeket tadja neki.
   
   nmethod errorgen(token,errorCode,params)
   // Kiad egy hibazenetet. Az zenet helye a token-ben specifiklt
   // hely lesz.
   // A params lehet nil is.

   nmethod incompErrorgen(token,errorcode,params)
   // Ez egy olyan hiba, amit csak akkor kell kiadni, ha pontosan
   // utnozni akarjuk a specifikcit. Ms szval itt a spec. rossz
   // s mi csinlnnk/csinljuk jl. Egy logikai rtkkel tr 
   // vissza, ha igaz, akkor a hibazenet ki van adva, ha hamis, 
   // akkor a hibazetet nem adta ki (lehet folytatni).
   // A paramterezse megegyezik az errorgen()-el.

   nmethod chkEndOFFile()
   // Elvgzi a szksges ellenrzseket a fil vgn.
   // (Lezratlan #if, etc.)
   
   rmethod oinit(inputReader,name,defDict,xtrDict,inclObj,errorStream)
   
metaclass
   
   rmethod onew(inputReader,name,defDict,xtrDict,inclObj,errorStream)


   rmethod oinitclass()

